#include "Board.h"
#include "Sound.h"

static int GHban;
static int GHhaikei;
static int GHblack;
static int GHwhite;
static int GHmasume;

static int masuY,masuX;			//}Xڂ̘g点邽߂̍W

static int CPU_BanData[ BAN_HEIGHT ][ BAN_WIDTH ] = {0};
static int CPU_BanData2[ BAN_HEIGHT ][ BAN_WIDTH ] = {0};

static int BanData[ BAN_HEIGHT ][ BAN_WIDTH ] =
{
	{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 2, 1, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 1, 2, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
	{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } 
} ;

//{[hɊւ摜f[^̃[h
void Board_init(){										
	GHban = LoadGraph(TEXT("摜/IZՖ.png"));
	GHhaikei = LoadGraph(TEXT("摜/wi.png"));
	GHblack = LoadGraph(TEXT("摜/R}.png"));
	GHwhite = LoadGraph(TEXT("摜/R}.png"));
	GHmasume = LoadGraph(TEXT("摜/}Xڌ.png"));

	int h,w;

	int init_BanData[ BAN_HEIGHT ][ BAN_WIDTH ] =		//{[h̏
	{
		{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 2, 1, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 1, 2, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, 0, 0, 0, 0, 0, 0, 0, 0, -1 } ,
		{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 } 
	} ;

	for(h = 0; h < BAN_HEIGHT ; h++){				//{[h̏
		for( w = 0; w < BAN_WIDTH ; w++){
			BanData[h][w] = init_BanData[h][w];
		}
	}
	Board_CPU_get();
	Board_CPU_get2();
}

//{[h`֐
void Board_Draw(){									

	int h, w;

	//wi̕`
	DrawGraph(0,0,GHhaikei,FALSE);

	//R}ƃ{[h̕`
	for( h = 1 ; h < BAN_HEIGHT -1 ; h ++ )
	{
		for( w = 1 ; w < BAN_WIDTH -1 ; w ++ )
		{
			switch(BanData[ h ][ w ] )
			{
			case BAN : 
				DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHban, TRUE);
				if( (h == masuY) && (w == masuX )){
					DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			case BLACK :
				DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHban, TRUE);
				DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHblack, TRUE);
				if( (h == masuY) && (w == masuX )){
					DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			case WHITE :
				DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHban, TRUE);
				DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHwhite, TRUE);
				if( (h == masuY) && (w == masuX )){
					DrawGraph(h*BAN_SIZE, w*BAN_SIZE, GHmasume, TRUE);
				}
				break;
			}
		}
	}
}

//R}u邩m߂֐
int Board_Search (int x ,int y ,int koma){				

	int dx = x;									//uƂR}̍WdxBɓĂ
	int dy = y;
	int vx = 0;
	int vy = 0;
	int flip_count = 0;
	int aitekoma;

	int i = 0;
	int j = 0;
	int k = 0;
	int m = 0;

	if(koma == BLACK){
		aitekoma = WHITE;
	}else{
		aitekoma = BLACK;
	}

	if( x < 1 || y < 1 || x > (BAN_WIDTH - 2) || y > (BAN_HEIGHT - 2))return flip_count;			//{[h͈͓̔ǂ

	if(BanData[x][y] != BAN)return flip_count;

	for(i = -1, x = dx+i; x <= (dx + 1) ; x = dx+ ++i){										//uƂĂR}̍W͂ɑ̃R}邩mF
		for(j = -1 ,y = dy+j; y <= (dy+1) ; y = dy+ ++j){
			if(BanData[x][y] == aitekoma){													
				vx = (x - dx),vy = (y - dy);												//̃R}Ԃ邩mFĂ߂
				for(k = 1; BanData[dx + k*vx][dy + k*vy] == aitekoma; k++){};				//Ԃ邩߂Ă
				if(BanData[dx + k*vx][dy + k*vy] == koma){
					for(m = 0; m < k; m++){
						BanData[dx + m*vx][dy + m*vy] = FLAG;							//̃R}܂ŒH蒅ЂԂR}̏ꏊɃtO𗧂ĂĂ
					}
					flip_count += 1;
				}
			}
		}
	}
	return flip_count;
}

//R}ЂԂ֐
void Board_Flip(int koma){
	int h,w;

	for( h = 1 ; h < BAN_HEIGHT -1 ; h ++ ){		//tO̗Ăꏊς
		for( w = 1 ; w < BAN_WIDTH -1 ; w ++ ){
			if(BanData[h][w] == FLAG){
				BanData[h][w] = koma;
				Sound_Board_koma();					//R}ԂʉĐ
			}
		}
	}
}

//v[[̓͊֐
int Board_Check_Mouse(int Mykoma){			

	int end = 0;

	int oldinput = 0;		
	int nowinput = 0;
	int edgeinput = 0;
	int mouseX = 0;
	int mouseY = 0;
	int x = 0; 
	int	y = 0;

	// }EX̓͏XV
	oldinput = nowinput ;
	nowinput = GetMouseInput() ;
	edgeinput = nowinput & ~oldinput ;
	GetMousePoint( &mouseX, &mouseY ) ;

	// }X̍WZo
	x = ( mouseX - BAN_LEFTUP_X ) / BAN_SIZE ;
	y = ( mouseY - BAN_LEFTUP_Y ) / BAN_SIZE ;

	// }X̍W󂯓n
	masuX = y;
	masuY = x;

	// }EX̍{^ꂽSearch֐ŒuꏊmF
	if( ( edgeinput & MOUSE_INPUT_LEFT ) != 0 ){
		switch(Board_Search(x,y,Mykoma)){
			case 0:
				end = 0;
				break;
			default:
				end = 1;
				break;
		}
	}
	return end;
}

//uR}邩ǂׂ֐
int Board_Check_End(int koma){
	int i,j;
	int Check_BanData[BAN_HEIGHT][ BAN_WIDTH ];			

	for(i = 1; i < BAN_HEIGHT-1 ; i++){				//{[h̏OăRs[Ă
		for( j = 1; j < BAN_WIDTH-1 ; j++){
			Check_BanData[i][j] = BanData[i][j];
		}
	}

	int h, w;
	int check_count = 0;
	
	for( h = 1 ; h < BAN_HEIGHT -1 ; h ++ ){		//WÂT[`֐֑
		for( w = 1 ; w < BAN_WIDTH -1 ; w ++ ){
			if(Board_Search(w,h,koma) >= 1){
				check_count += 1;
			}
		}
	}

	for(i = 1; i < BAN_HEIGHT-1 ; i++){				//{[h̏߂
		for( j = 1; j < BAN_WIDTH-1 ; j++){
			BanData[i][j] = Check_BanData[i][j];
		}
	}
	return check_count;
}

//ǂ炪
int Board_Check_Winner(int Mykoma){

	int h,w,user=0,cpu=0,black=0,white=0;

	enum winner winner = NOONE;

	//R}𐔂グ
	for(h = 1 ; h < BAN_WIDTH -1 ; ++h){
		for(w = 1 ; w < BAN_HEIGHT -1 ; ++w){
			switch(BanData[h][w]){
				case BLACK:
					++black;
					break;
				case WHITE:
					++white;
					break;
				default :
					break;
			}
		}
	}

	if(Mykoma == BLACK){							//v[[̃R}ꍇ
        user = black,
        cpu = white;
	}else{											//ꍇ
        user = white,
        cpu = black;
	}

	if(user > cpu){
		winner = USER;
	}else if(cpu > user){
		winner = CPU;
	}else{
		winner = DRAW;
	}
	return winner;
}

//CPUvlp̃{[h֐iCPU{[h񂩂Ճf[^ցj
void Board_CPU_give(){
	int i,j;

	for(i = 0; i < BAN_HEIGHT ; i++){				//{[h̏ɖ߂
		for( j = 0; j < BAN_WIDTH ; j++){
			BanData[i][j] = CPU_BanData[i][j];
		}
	}
}

//CPUvlp̃{[h֐iՃf[^CPU{[hցj
void Board_CPU_get(){
	int i,j;

	for(i = 0; i < BAN_HEIGHT ; i++){				//{[h̏ۂĂ
		for( j = 0; j < BAN_WIDTH ; j++){
			CPU_BanData[i][j] = BanData[i][j];
		}
	}
}

void Board_CPU_give2(){
	int i,j;

	for(i = 0; i < BAN_HEIGHT ; i++){				//{[h̏ɖ߂
		for( j = 0; j < BAN_WIDTH ; j++){
			BanData[i][j] = CPU_BanData2[i][j];
		}
	}
}

void Board_CPU_get2(){
	int i,j;

	for(i = 0; i < BAN_HEIGHT ; i++){				//{[h̏ۂĂ
		for( j = 0; j < BAN_WIDTH ; j++){
			CPU_BanData2[i][j] = BanData[i][j];
		}
	}
}